MultiplanParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
MultiplanParser Class Referencefinal

the main class to read a Multiplan document More...

`#include <MultiplanParser.hxx>`

Inheritance diagram for MultiplanParser:

## Public Member Functions
| MultiplanParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor More...
| ~MultiplanParser () final
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGSpreadsheetInterface *documentInterface) final
| the main parse function More...
Public Member Functions inherited from MWAWSpreadsheetParser
| ~MWAWSpreadsheetParser () override
| destructor More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | createDocument (librevenge::RVNGSpreadsheetInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones More...
bool | readColumnsPos ()
| read the columns limits pos More...
bool | readHeaderFooter ()
| read the header/footer strings, ... More...
bool | readPrinterInfo ()
| read the printer information More...
bool | readPrinterMessage ()
| read the printer message More...
bool | readZonesList ()
| read the spreadsheet zone list More...
bool | readZone1 (MWAWEntry const &entry)
| read an unknown zone: two blocks of 60 bytes More...
bool | readCellDataPosition (MWAWEntry const &entry)
| read the cell data position More...
bool | readLink (int pos, MWAWCellContent::FormulaInstruction &instruction)
| read a link given a position More...
bool | readLinkFilename (int pos, MWAWCellContent::FormulaInstruction &instruction)
| read a link filename More...
bool | readSharedData (int pos, int cellType, MWAWVec2i const &cellPos, MWAWCellContent &content)
| read a shared data More...
bool | readName (int pos, MWAWCellContent::FormulaInstruction &instruction)
| reads a name and returns the cell's instruction More...
bool | readZoneB ()
| read an unknown zone More...
bool | readZoneC ()
| read an unknown zone More...
bool | sendSpreadsheet ()
| try to send the main spreadsheet More...
bool | sendText (MWAWEntry const &entry)
| try to send a text zone More...
bool | sendCell (MWAWVec2i const &cellPos, int pos)
| try to send a cell More...
bool | readDouble (double &value)
| try to read a double value More...
bool | readFormula (MWAWVec2i const &cellPos, std::vector< MWAWCellContent::FormulaInstruction > &formula, long endPos, std::string &extra)
| try to read a formula More...
Protected Member Functions inherited from MWAWSpreadsheetParser
| MWAWSpreadsheetParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWSpreadsheetParser (MWAWParserStatePtr const &state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes
std::shared_ptr< MultiplanParserInternal::State > | m_state
| the state More...

## Friends
class | MultiplanParserInternal::SubDocument

## Detailed Description

the main class to read a Multiplan document

Note
  need more files to be sure to treat all documents

## Constructor & Destructor Documentation

## ◆ MultiplanParser()

MultiplanParser::MultiplanParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

## ◆ ~MultiplanParser()

MultiplanParser::~MultiplanParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool MultiplanParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void MultiplanParser::createDocument | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool MultiplanParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ parse()

void MultiplanParser::parse | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |
| finalvirtual

the main parse function

Implements MWAWSpreadsheetParser.

## ◆ readCellDataPosition()

bool MultiplanParser::readCellDataPosition | ( | MWAWEntry const & | entry | ) |
| protected

read the cell data position

Referenced by readZonesList().

## ◆ readColumnsPos()

bool MultiplanParser::readColumnsPos | ( |  | ) |
| protected

read the columns limits pos

Referenced by createZones().

## ◆ readDouble()

bool MultiplanParser::readDouble | ( | double & | value | ) |
| protected

try to read a double value

Referenced by readFormula(), readSharedData(), and sendCell().

## ◆ readFormula()

bool MultiplanParser::readFormula | ( | MWAWVec2i const & | cellPos,
|  | std::vector< MWAWCellContent::FormulaInstruction > & | formula,
|  | long | endPos,
|  | std::string & | extra
| ) |  |
| protected

try to read a formula

Referenced by readSharedData(), and sendCell().

## ◆ readHeaderFooter()

bool MultiplanParser::readHeaderFooter | ( |  | ) |
| protected

read the header/footer strings, ...

Referenced by createZones().

## ◆ readLink()

bool MultiplanParser::readLink | ( | int | pos,
|  | MWAWCellContent::FormulaInstruction & | instruction
| ) |  |
| protected

read a link given a position

Referenced by readFormula().

## ◆ readLinkFilename()

bool MultiplanParser::readLinkFilename | ( | int | pos,
|  | MWAWCellContent::FormulaInstruction & | instruction
| ) |  |
| protected

read a link filename

Referenced by readLink().

## ◆ readName()

bool MultiplanParser::readName | ( | int | pos,
|  | MWAWCellContent::FormulaInstruction & | instruction
| ) |  |
| protected

reads a name and returns the cell's instruction

Referenced by readFormula().

## ◆ readPrinterInfo()

bool MultiplanParser::readPrinterInfo | ( |  | ) |
| protected

read the printer information

Referenced by createZones().

## ◆ readPrinterMessage()

bool MultiplanParser::readPrinterMessage | ( |  | ) |
| protected

read the printer message

Referenced by createZones().

## ◆ readSharedData()

bool MultiplanParser::readSharedData | ( | int | pos,
|  | int | cellType,
|  | MWAWVec2i const & | cellPos,
|  | MWAWCellContent & | content
| ) |  |
| protected

read a shared data

Referenced by sendCell().

## ◆ readZone1()

bool MultiplanParser::readZone1 | ( | MWAWEntry const & | entry | ) |
| protected

read an unknown zone: two blocks of 60 bytes

Referenced by readZonesList().

## ◆ readZoneB()

bool MultiplanParser::readZoneB | ( |  | ) |
| protected

read an unknown zone

Referenced by createZones().

## ◆ readZoneC()

bool MultiplanParser::readZoneC | ( |  | ) |
| protected

read an unknown zone

Referenced by createZones().

## ◆ readZonesList()

bool MultiplanParser::readZonesList | ( |  | ) |
| protected

read the spreadsheet zone list

Referenced by createZones().

## ◆ sendCell()

bool MultiplanParser::sendCell | ( | MWAWVec2i const & | cellPos,
|  | int | pos
| ) |  |
| protected

try to send a cell

Referenced by sendSpreadsheet().

## ◆ sendSpreadsheet()

bool MultiplanParser::sendSpreadsheet | ( |  | ) |
| protected

try to send the main spreadsheet

Referenced by parse().

## ◆ sendText()

bool MultiplanParser::sendText | ( | MWAWEntry const & | entry | ) |
| protected

try to send a text zone

Referenced by MultiplanParserInternal::SubDocument::parse().

## Friends And Related Function Documentation

## ◆ MultiplanParserInternal::SubDocument

friend class MultiplanParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<MultiplanParserInternal::State> MultiplanParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), readCellDataPosition(), readColumnsPos(), readFormula(), readHeaderFooter(), readLink(), readLinkFilename(), readName(), readPrinterInfo(), readPrinterMessage(), readSharedData(), readZoneB(), readZonesList(), sendCell(), sendSpreadsheet(), and sendText().

The documentation for this class was generated from the following files:

- MultiplanParser.hxx
- MultiplanParser.cxx